/**
	Definitions for 4cubes program
	Fraga 28/11/2000
**/
#ifndef CUBO_H
#define CUBO_H

#include <qwidget.h>
#include <qgl.h>
#include <qtimer.h>

class Cube : public QGLWidget
{
	Q_OBJECT  // must include this if you use Qt signals/slots
public:
	Cube( QWidget *parent=0, const char *name=0 );
	QSizePolicy sizePolicy() const;
	void getPosition ( int *x, int *y ) { *x = xmouse; *y = ymouse; }
	void getSize ( int *w, int *h ) { 
		*w = windowWidth; *h = windowHeight; 
	}

public slots:
	void timerDone( void );
	void initscreen( void ) { 
		timer->start(100);
	}
	void stop( void ) {
		timer->stop( );
 	} 

signals:
	void changePos( ); // called when mouse is moved
	void changeSize( ); // called when windows is resized
 
protected:
	void initializeGL( void );
	void resizeGL( int w, int h );
	void paintGL( void );
	void mouseMoveEvent( QMouseEvent * );
	// void mousePressEvent( QMouseEvent * );
 
 
private:
	void getcube ( float cx, float cy, float cz, float size, float v[8][3] );
	void show_cube ( float v[8][3] );

	QTimer *timer;

	int windowWidth, windowHeight;   // canvas width and height

	float c1[8][3], c2[8][3]; // Vertices data for each cube
	float c3[8][3], c4[8][3];
	float c5[8][3];

	float yrot, xrot;  // Encene rotation

	float helix, body;
	float angle;
	int signo;
	int xmouse, ymouse;  // Mouse pointer coordinates
};


#endif // CUBO_H
