#include <qapplication.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qfont.h>
#include <qlayout.h>
#include <qstring.h>
#include <qcombobox.h>
#include <qlistbox.h>
#include <qhbox.h>
#include <qpen.h>
#include <qnamespace.h>


#include "painter.h"
#include "cubes.h"


Painter::Painter( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
    setMinimumSize( 500, 355 );

    QPushButton *quit = new QPushButton( "Quit", this, "quit" );
    quit->setFont( QFont( "Times", 14, QFont::Bold ) );
    connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );

    cube = new Cube( this, "cube" );
	connect( cube, SIGNAL(changePos()), SLOT(newPosition( )) );
	connect( cube, SIGNAL(changeSize()), SLOT(newSize( )) );

    myinit = new QPushButton( "Init", this, "myinit" );
    myinit->setFont( QFont( "Times", 14, QFont::Bold ) );
    connect( myinit, SIGNAL(clicked()), cube, SLOT(initscreen()) );

    stop = new QPushButton( "Stop", this, "stop" );
    stop->setFont( QFont( "Times", 14, QFont::Bold ) );
    connect( stop, SIGNAL(clicked()), cube, SLOT(stop()) );

    QGridLayout *grid = new QGridLayout( this, 1, 2, 5 ); //2x2, 5 pixel border
    grid->addWidget( cube, 0, 1 );
    grid->setColStretch( 1, 10 );

    messpos = new QLabel( this, "messagepos"  );
    messpos->setMaximumHeight( 20 );
    messpos->setFrameStyle( QFrame::WinPanel | QFrame::Sunken );
    messpos->setBackgroundColor( messpos->colorGroup().base() );
    messpos->setAlignment( AlignCenter );

    messize = new QLabel( this, "message_size"  );
    messize->setMaximumHeight( 20 );
    messize->setFrameStyle( QFrame::WinPanel | QFrame::Sunken );
    messize->setBackgroundColor( messpos->colorGroup().base() );
    messize->setAlignment( AlignCenter );

    // Labels for the new displays...
    visorMouse = new QLabel(this, "message_size"  );
    visorMouse->setMaximumHeight( 20 );
    visorMouse->setText("Mouse:");
    visorMouse->setAlignment( AlignCenter );

    // Labels for the new displays...
    visorTama = new QLabel(this, "message_size"  );
    visorTama->setMaximumHeight( 20 );
    visorTama->setText("Tamao:");
    visorTama->setAlignment( AlignCenter );

	QVBoxLayout *leftBox = new QVBoxLayout;
	grid->addLayout( leftBox, 0, 0 );
	leftBox->addWidget( quit );
	leftBox->addWidget( myinit );
	leftBox->addWidget( stop );
	leftBox->addWidget(visorMouse);
	leftBox->addWidget( messpos );
	leftBox->addWidget(visorTama);
	leftBox->addWidget( messize );
}

void Painter::newPosition( )
{
	int mx, my;

	cube->getPosition( &mx, &my );

    QString s;
	messpos->setText( s.sprintf("%d,%d", mx, my ) );
}

void Painter::newSize( )
{
	int mx, my;

	cube->getSize( &mx, &my );

    QString s;
	messize->setText( s.sprintf("%d,%d", mx, my ) );
}

